<template>
   <div class="map">
      <div id="map" style="width: 100%; height: 100%"></div>
   </div>
</template>

<script setup lang="ts">
import L from "leaflet"
import "leaflet.markercluster"
import "leaflet.markercluster/dist/MarkerCluster.Default.css"
import "leaflet/dist/leaflet.css"
import { onMounted } from "vue"
import { IInvestmens } from "@/views/Investments/store"
import { watch } from "vue"
import type { Feature } from "geojson"

const props = defineProps<{
   markers?: IInvestmens[]
   lineStringList?: Feature[]
}>()

interface MyLayer extends L.Layer {
   _url: string
}

const url = "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"
const osmLayer = L.tileLayer(url, {
   maxZoom: 18
})
const markerIcon = L.icon({
   iconSize: [25, 41],
   iconAnchor: [10, 41],
   popupAnchor: [2, -40],
   iconUrl: "https://unpkg.com/leaflet@1.4.0/dist/images/marker-icon.png",
   shadowUrl: "https://unpkg.com/leaflet@1.4.0/dist/images/marker-shadow.png"
})

let map: L.Map

onMounted(() => {
   const center = L.latLng(49.8941184, 20.6062071)
   map = L.map("map", { center: center, zoom: 10, layers: [osmLayer], maxZoom: 18 })

   //addMarkers()
   addLineStringList()
})

watch(
   () => props.markers,
   () => {
      addMarkers()
   },
   {
      deep: true
   }
)
watch(
   () => props.lineStringList,
   () => {
      addLineStringList()
   },
   {
      deep: true
   }
)
const addMarkers = () => {
   if (!props.markers) return
   const location = props.markers.map((item) => {
      return {
         lat: item.geo_place?.coordinates[1],
         long: item.geo_place?.coordinates[0],
         city: item.place.name,
         name: item.name
      }
   })

   const markerCluster = new L.MarkerClusterGroup()

   for (let i = 0; i < location.length; i++) {
      if (location[i].lat === null || location[i].long === null) continue

      const lat = location[i].lat
      const long = location[i].long
      const city = location[i].name

      const marker = L.marker(new L.LatLng(lat, long), {
         icon: markerIcon
      })

      marker.bindPopup(city)

      if (map.getZoom() > 15 && map.hasLayer(marker)) {
         map.closePopup()
      }
      markerCluster.addLayer(marker)
   }

   map.eachLayer((layer) => {
      if (url !== (layer as MyLayer)._url) {
         map.removeLayer(layer)
      }
   })

   if (markerCluster.getLayers().length > 0) {
      map.addLayer(markerCluster)
      map.fitBounds(markerCluster.getBounds(), { maxZoom: 18 })
   }
}

const addLineStringList = () => {
   map.eachLayer((layer) => {
      if (layer instanceof L.GeoJSON) {
         map.removeLayer(layer)
      }
   })

   if (!props.lineStringList?.length) {
      return
   }
   props.lineStringList.forEach((lineString) => {
      const layerJson = L.geoJSON(lineString)
      layerJson.addTo(map)
      if (lineString.properties) {
         layerJson.bindPopup(lineString.properties.name)
      }
      layerJson.addEventListener("click", () => {
         layerJson.setStyle({ color: "#ff7800", weight: 5, opacity: 0.8 })
         layerJson.openPopup()
      })
      layerJson.addEventListener("mouseout", () => {
         layerJson.setStyle({ color: "#3388ff", weight: 3, opacity: 1.0 })
         layerJson.closePopup()
      })
   })
   map.fitBounds(L.geoJSON(props.lineStringList).getBounds(), { maxZoom: 18 })
}
</script>

<style scoped>
.map {
   flex: 1;
   border-right: 1px solid var(--border-color);
}
</style>
